
#define LISTELEMENTNOTFOUND -1

class List {
  
  struct intListElement {
    intListElement *prev, *next;
    int content;
    intListElement(int *_content = NULL, 
		intListElement *_prev = NULL, 
		intListElement *_next = NULL){
      prev = _prev;
      next = _next;
      content = *_content;
    }
  };

 public:
 struct intList {
   intListElement *start, *end;

   intList(){ 
    start=NULL;
     end=NULL;
   }
    ~intList() {
     intListElement *pos = start;
     intListElement *del;
     while(pos !=NULL) {
       del = pos;
       pos=pos->next;
       delete del;
       }
   }



 public:

    void clear() {
      
      intListElement *pos = start;
      intListElement *del;
      while(pos !=NULL) {
	del = pos;
	pos=pos->next;
	delete del;
       }
      start=NULL;
      end=NULL;
    }


   void add(int content) {
     intListElement *el = new intListElement(&content, end);
     if (start == NULL) start =el;
     else end->next = el;
     end = el;
   }// end add


   unsigned int length() {
     int count = 0;
     intListElement *pos=start;
     while (pos !=NULL){
       pos = pos->next;
       count++;
     } 
     return count;

 }// end listlength
   
     void remove(intListElement *element) {
       if((element == start) && (element == end)) {
	 start = NULL;
	 end = NULL;
       }
       else if(element == start){
	 start = element->next;
	 element->next->prev = NULL;
       }
       else if (element == end) {
	 end = element->prev;
	 element->prev->next = NULL;
       }
       else {
	 element->prev->next = element->next;
	 element->next->prev = element->prev;
       }
       delete element;
     }
   
   void remove(int pos) {
     intListElement *elhelp = start;
     for( int i = 0; i<pos; i++) {
       if (elhelp == NULL) return;
       elhelp = elhelp->next;
     }
if (elhelp == NULL) return;
     remove(elhelp);

   }
   

   int find(int findInt) {
     if(start == NULL) return LISTELEMENTNOTFOUND;
     intListElement *elhelp = start;
     int iCount = 0;

     while (elhelp->content != findInt) {
       if (elhelp->next == NULL) return LISTELEMENTNOTFOUND;
       iCount++;
       elhelp = elhelp->next;
     }
     return iCount;
   }

   int getContent(int &value,int pos = 0){
      intListElement *elhelp = start;
     for( int i = 0; i<pos; i++) {
       if (elhelp == NULL) return LISTELEMENTNOTFOUND;
       elhelp = elhelp->next;
     }
     if (elhelp == NULL) return LISTELEMENTNOTFOUND;
     value = elhelp->content;
     return 1;
   }
   
   int isempty(){
     if(start == NULL)
       return 1;
     return 0;
   }

 };// end struct intlist 

}; // end class List



