
#include <iostream>
#include <string>
#include <cstdlib>

#include <stdio.h>

#include <stdlib.h>
#include <time.h>

#include <gtk/gtk.h>

#include <xmms/plugin.h>
#include <xmms/xmmsctrl.h>


#include "mylist.h"
#include "configuration.h"
#include "database.h"



#ifndef VERSION
#define VERSION "0.4.2-3"
#endif


/* XRP = Xmms Rate Plug */
/* defines the assessment buffer (XRP_SONGMAXASSESSMENT * SongLength)
   at the beginning and end of a song where the assessment is maximal*/
#define XRP_SONGMAXASSESSMENT 0.05


using namespace std;


void failurecerrhandling (int failure, const char *text);

extern "C" void init();
extern "C" void about();
extern "C" void configure();
extern "C" void cleanup();
extern "C" GeneralPlugin *get_gplugin_info();


void listResetNotPlayedFileList(List::intList &list);

void resetTimeout (int newTimeout);

int timeoutFunction(gpointer);


GeneralPlugin rateplug = { NULL,
			   NULL,
			   -1,
			   "Rate&Ignore Plugin "VERSION,
			   init,
			   about,
			   configure,
			   cleanup};


/* to remove xmms shuffle feature*/
gint reinitXmmsShuffle();

/*
  global config values
*/
/* timeout on/off??*/
gint iTimeout = 0;

/* plugin on*/
gint iPluginEnable = 0;

/*
  global mainhelp values;
*/
int iLastSongLength = 0, iLastSongLastPosition = 0;
int iLastPlaylistPosition = 0;
string strLastPlayedFile ="";
List::intList listNotPlayedFiles;
/* the guessed max Rating of the whole Playlist*/
int iRateMax = DATABASERATEMAX;
/* save last Timeout*/
int iOldTimeout;
/* save the first and the last song of the playlist to check if it was changed*/
string strFirstSongInPlaylist ="";
string strLastSongInPlaylist ="";
int iLastPlaylistLength = 0;
int iTimeoutAvoidFromStopping = -1;

/* once more: to trick xmms shuffle function*/
int iSongChangedInLastTimeout = 1;
int iTimeoutGetNextSongInXmmsShuffleList = 0;
string strNextSongGetNextSongInXmmsShuffleList="";
void getNextSongInXmmsShuffleList();
gint timeoutGetNextSongInXmmsShuffleList(gpointer);

/* save the last play state in xmms*/
gint iLastTimeoutPlay=0;

Database::ASCIIDatabase *db = NULL;
Config *config = NULL;


/* 
   GeneralPlugin functions
*/

extern "C"{
 void init() {
    time_t timeSek;

    db = new Database::ASCIIDatabase;
    config  = new Config(&rateplug, db);
    
    /* read global config values*/
   
   switch (config->readValues()){
     /* try again*/
     case CONFIGOK :break;
   case CONFIGCANNOTREAD: if(config->readValues()) break; else  exit (-1);
     default: exit(-1);
   }

   /* init random number func*/
  time(&timeSek);
 srand(unsigned(timeSek));
   

 /* set db location*/
 db->setLocation(config->cDatabaseLocation);

 iPluginEnable = 1;
 iTimeout = gtk_timeout_add(config->iTimeout, timeoutFunction, NULL);
 iOldTimeout = config->iTimeout;
 

 // listResetNotPlayedFileList(listNotPlayedFiles);


 } /* end init()*/
}

extern "C" {
 void about() {
   config->createAboutWindow();
 }/* end about()*/
}

extern "C"{
 void configure() {
   /* plugin enabled??*/
   if (iPluginEnable == 0) {
       xmms_show_message("Rate&Ignore Plugin Error", "Please enable the Rate&Ignore Plugin before you try to configure.\nIt's necessary for full function support.", "OK", TRUE, NULL, NULL);
       return;
   }

   config->createConfigWindow();
   config->refreshConfigWindow(xmms_remote_get_playlist_pos(rateplug.xmms_session));

 }/* end configure()*/
}

extern "C"{
 void cleanup() {
   /* kill timeout*/
   if(iTimeout){
     gtk_timeout_remove(iTimeout);
     iPluginEnable = 0;
   }
   if (iTimeoutAvoidFromStopping) {
     gtk_timeout_remove(iTimeoutAvoidFromStopping);
   }
   /* save values*/
   config->saveValues();

   /* deletes*/
   delete config;
   delete db;
   config = NULL;
   db = NULL;

 }/* end close()*/
}

extern "C" {
GeneralPlugin *get_gplugin_info(void)
{
	return &rateplug;
}
}












/*
  timeoutFunction
  main loop with active waiting 
  (<-sorry, but i haven't worked out how to capture keys)
*/
 int timeoutFunction(gpointer gpData){

  gint iPlaylistPosition;
  gchar *cFile = NULL;
  string strhelp = "";
  long lPos;
  int iShuffle;
  int iRate = DATABASERATEMAX/2, iIsRepeat, iPosList = 0, iHowManySongsToPlay;
  /* in while*/
  int iCountWhile = 0, iRateMaxTemp = 0, ihelp, iWhileMod;
  
  string strhelp1, strhelp2;
  gchar *gcHelp1;
  
  Database::ASCIIDatabase::data *data = new Database::ASCIIDatabase::data;
  
  if (iTimeoutGetNextSongInXmmsShuffleList){
    delete data;
    return 1;
  }
  
  if (iSongChangedInLastTimeout && (!listNotPlayedFiles.isempty())) {
   //update cNextFileInXmmsShuffleList
    getNextSongInXmmsShuffleList();
    /* reset*/
    
    iSongChangedInLastTimeout = 0;
    delete data;
    return 1;
  }/*fi iNeedToUpdate*/


  
  /* detect a changed playlist*/

  ihelp = xmms_remote_get_playlist_length(rateplug.xmms_session);
  if(ihelp < 1){ 
    delete data;
    return 1;
  }
  
  // bis hier ist alles ok
  gcHelp1 = xmms_remote_get_playlist_file(rateplug.xmms_session, 0);
  strhelp1 = (string) gcHelp1;
  if (gcHelp1){
    g_free(gcHelp1);
    gcHelp1 = NULL;
  }
  
  gcHelp1 = xmms_remote_get_playlist_file(rateplug.xmms_session, ihelp - 1);
  strhelp2 = (string) gcHelp1;
  if(gcHelp1){
    g_free(gcHelp1);
    gcHelp1=NULL;
  }
   

  if ((ihelp != iLastPlaylistLength) ||
      (strhelp1 != strFirstSongInPlaylist) ||
      (strhelp2 != strLastSongInPlaylist)){

    iLastPlaylistLength = ihelp;
    strFirstSongInPlaylist = strhelp1;
    strLastSongInPlaylist = strhelp2;
    
    listResetNotPlayedFileList(listNotPlayedFiles);
    iRateMax = DATABASERATEMAX;
  }

  
  
  /* to avoid useless calls and chaos*/
  iPlaylistPosition = xmms_remote_get_playlist_pos(rateplug.xmms_session);
  if (cFile) {
    g_free(cFile);
    cFile = NULL;
  }

  cFile = xmms_remote_get_playlist_file(rateplug.xmms_session, iPlaylistPosition);


  /* just do something if xmms is playing and the song was changed*/
  if ((xmms_remote_is_playing(rateplug.xmms_session))
      &&(!(strLastPlayedFile == (string) cFile))) {
    /*okelydokely lets rock*/
      iSongChangedInLastTimeout = 1;
      /* stop playing and reset playedfileslist*/
    if(listNotPlayedFiles.isempty()) {
      xmms_remote_stop(rateplug.xmms_session);
      listResetNotPlayedFileList(listNotPlayedFiles);
      iRateMax = DATABASERATEMAX;
    }
   
    /*
     * why i use a listNotPlayedFiles:
     * this list contains the playlist position of the files which
     * haven't been played until now. Perhaps you ask yourself
     * 1. why this %&$" guy, who programmed this plugin, doesn't use
     *    a list which contains the played Files.
     * 2. why i wrote a half novel instead of a short comment ;)
     * 1.: Yes you're right. A listPlayedFiles would need less operations 
     *     and seems to be the right choice. But this operations have to be made 
     *     while choosing the next song. This is a critical moment. 
     *     The listNotPlayedFiles accelerates the new song selection.
     * 2.: I think my english reading skills are good. But my writing skills 
     *     are increasable. So i must write, write, write .....
     */

    /*
     * shuffle new song??
     * if the song which is playing is not the same as 
     * the expected song -> user selected explicit this song
     * -> do nothing
     */
    if(xmms_remote_is_shuffle(rateplug.xmms_session)
       && 
       (strNextSongGetNextSongInXmmsShuffleList == (string)(xmms_remote_get_playlist_file(rateplug.xmms_session, xmms_remote_get_playlist_pos(rateplug.xmms_session))))){

      
      if (gcHelp1) {
	g_free(gcHelp1);
	gcHelp1 = NULL;
      }


      /* avoid useless calls*/
      iIsRepeat = xmms_remote_is_repeat(rateplug.xmms_session);
      


      /*search new song*/

      /* accelerate the whole process*/
      if (!iIsRepeat)
	iHowManySongsToPlay = listNotPlayedFiles.length();
      else 
	iHowManySongsToPlay = xmms_remote_get_playlist_length(rateplug.xmms_session);

      do {
	/*
	 * to accelerate the process if there are only low rated songs
	 * left in the listNotPlayedFiles
	 * if i looped twice the length of the listNotPlayedFiles than
	 * i guess that there's no song left with higher rating than
	 * the highest rate which appeared until now.
	 */
	iCountWhile++;
	if(iCountWhile > 2 * iHowManySongsToPlay){
	  iRateMax = iRateMaxTemp;
	}

	if(iRateMax > 0)
	  iWhileMod = rand () % iRateMax;
	else {
	    xmms_remote_stop(rateplug.xmms_session);
	    delete data;
	    return 1;
	}




	iShuffle = (rand() % iHowManySongsToPlay);
	if (!iIsRepeat){
	  iPosList = iShuffle;
	  listNotPlayedFiles.getContent(iShuffle, iShuffle);
	}

	/* get rating of selected song*/
	gcHelp1  = xmms_remote_get_playlist_file(rateplug.xmms_session, iShuffle);
	strhelp = (string)gcHelp1;
	if (gcHelp1) {
	  g_free(gcHelp1);
	  gcHelp1=NULL;
	}

	strhelp.erase(0, strhelp.rfind("/")+1);
	switch (db->search(&strhelp, lPos)) {
	  case DATABASECANNOTFINDENTRY: iRate = DATABASERATEMAX/2;break;
	   default: 
	     db->read(*data, lPos);
	     iRate = data->getRate();
	     break;
	}



	/* remove all songs with ignore value from list*/
	if (iRate == 0){
	  listNotPlayedFiles.remove(iPosList);
	  continue;
	}
	

	/* save the highest rate which appeared until now*/
	iRateMaxTemp = (iRateMaxTemp < iRate) ? iRate : iRateMaxTemp;

      }while(iRate < iWhileMod);



      

      if (!iIsRepeat) {
	listNotPlayedFiles.remove(iPosList);
      }
	

    xmms_remote_set_playlist_pos(rateplug.xmms_session, iShuffle);
    

    /* update cFile + iPlaylistPosition*/
    if (cFile) {
      g_free(cFile);
      cFile = NULL;
    }
    cFile = xmms_remote_get_playlist_file(rateplug.xmms_session, iShuffle);
    iPlaylistPosition = iShuffle;

    
    /* yes. update at next timeout call*/
    //iSongChangedInLastTimeout = 1;
    

    }  /* if shuffle == TRUE*/
    
    else {
      /* if the song was selected explicit remove it too*/
      if(xmms_remote_is_shuffle(rateplug.xmms_session)) {
	if (!xmms_remote_is_repeat(rateplug.xmms_session)){
	  if ((ihelp = listNotPlayedFiles.find(xmms_remote_get_playlist_pos(rateplug.xmms_session))) > -1) {
	listNotPlayedFiles.remove(ihelp);
	  }
	}
      }
    }

    

    /* refresh config Window*/
    config->refreshConfigWindow(iPlaylistPosition);
   
    /*
      RATING
    */

    /*
     * song was skipped away?? 
     * 1000 cause timeout=500
     * sometimes iLastSongPosition is a big negative int
     * This happens when the song is skipped and
     * output_time is called during refreshing xmms.
     * This doesn't matter cause it works. 
     * (Substract a negative int -> add -> >1000)
     * But perhaps this could envolve to a full-grown bug
     */
     if ((iLastSongLength - iLastSongLastPosition) > 1000) {
       /* if skiped in first X percent of Song
	  -> max negative assessment*/
       if(iLastSongLastPosition < (XRP_SONGMAXASSESSMENT * iLastSongLength)) {
	 iRate = -1 * config->iRatingSongSkiped;
       }
       /* song skiped in last X percent of song
	  -> max positive assessment */
       else if (iLastSongLastPosition > ((1-XRP_SONGMAXASSESSMENT) * iLastSongLength)) {
	 iRate = config->iRatingSongHeared;
       }
       /* else -> linear assessment*/
       else {
	 iRate = (signed int)(((iLastSongLastPosition - (XRP_SONGMAXASSESSMENT * iLastSongLength))/(signed int)((iLastSongLength * (1-(2*XRP_SONGMAXASSESSMENT)))/(config->iRatingSongSkiped + config->iRatingSongHeared))) - config->iRatingSongSkiped);
	 /* ^^^^ THIS rocks!!*/
       }
     }
   


     strhelp = strLastPlayedFile;
     if(strhelp != "") {
       /* okay now write it*/

       data->setName(strhelp);
    switch (db->search(&data->getName() ,lPos)){
      case DATABASECANNOTOPEN: failurecerrhandling(DATABASECANNOTOPEN,"");break;

      case DATABASECANNOTFINDENTRY:
	data->setRate(DATABASERATEMAX/2);
	db->write(data, 0, DATABASEAPPEND);
	break;
      
      default:
	if (lPos > -1) {
	  db->read(*data, lPos);
	
	  /* modify Rating*/
	  if((ihelp  = data->getRate()) != 0){
	    ihelp += iRate;
	    /* 0 = Ignore*/
	    ihelp = (ihelp < 1) ? 1 : ihelp;
	  }
	  else {
	    ihelp += iRate;
    	    ihelp = (ihelp < 0) ? 0 : ihelp;
	  }


	  data->setRate(ihelp);
	  

	  db->modify(data, lPos);
	}
    }/* end switch*/

     }


     /* get new values*/
     /* save values for next calc*/
     iLastSongLength = xmms_remote_get_playlist_time(rateplug.xmms_session, iPlaylistPosition);
     iLastPlaylistPosition = iPlaylistPosition;
     //     *cLastPlayedFile = cFile;
     strLastPlayedFile = (string) cFile;
     //     memcpy(cLastPlayedFile,
  }/* end if something changed*/

     

  /* all other timeout calculations*/

  /* timeout changed*/
  if (iOldTimeout != config->iTimeout) {
    resetTimeout(config->iTimeout);
      iOldTimeout = config->iTimeout;
  }

 
  /* get playtime->calc skip*/
  iLastSongLastPosition = xmms_remote_get_output_time(rateplug.xmms_session);
 
 

  // edit shuffle list to avoid xmms from stopping
  //  if(iTimeoutAvoidFromStopping == -1) {
  //  iTimeoutAvoidFromStopping = gtk_timeout_add(config->iTimeout/2, reinitXmmsShuffle, NULL);
  //    }



    
  if (xmms_remote_is_playing(rateplug.xmms_session)){
    iLastTimeoutPlay=1;
  }
  else {
    iLastTimeoutPlay=0;
  }


  if (cFile) {
    g_free(cFile);
    cFile =NULL;
  }
  if(gcHelp1){
    g_free(gcHelp1);
    gcHelp1= NULL;
  }
  if(data)
    delete data;
  
return TRUE;
 }/* end timeoutFunction()*/
  




 void listResetNotPlayedFileList(List::intList &list) {

   /* destruct list*/
  list.clear();

  for(int i = 0;i<xmms_remote_get_playlist_length(rateplug.xmms_session);i++){
      list.add(i);
    }

 } /* end listResetNotPlayedFileList()*/



/*
  reset timeout
*/


void resetTimeout(int iTimeoutValue) {
     if(iTimeout) gtk_timeout_remove(iTimeout);
    iTimeout = gtk_timeout_add(iTimeoutValue, timeoutFunction, NULL);
}






/*
  Failurehandling
*/

 void failurecerrhandling (int failure, const char *text) {

  string standardText;

  switch(failure) {
  case DATABASECANNOTOPEN :
    standardText = "cannot open database: please check if the file configured exist. ";
    break;
  case DATABASECANNOTREAD :
    standardText = "cannot read from database: ";
    break;
  case DATABASECANNOTWRITE :
    standardText ="cannot write to database: ";
    break;
  default:
    standardText = "A failure occurs. But i don't know which: ";
    break;
  }

  cerr << standardText << text << endl;

 }/* end failurecerrhandling()*/



gint reinitXmmsShuffle(){
  
  /*
   *  add the first file at the end of the list and then....
   * remove it!!
   * it's an ugly trick
   * Xmms stops playing files if it reaches the last song in 
   * the shuffled list
   * cause I implement my own shuffle i don't want this feature
   * So I must change the playlist every time when the song was changed,
   * to prevent xmms from stopping
   */

  char *chelp;


         chelp = xmms_remote_get_playlist_file(rateplug.xmms_session,0);

	 xmms_remote_playlist(rateplug.xmms_session, &chelp, 1, TRUE);
	 xmms_remote_playlist_delete(rateplug.xmms_session,xmms_remote_get_playlist_length(rateplug.xmms_session) - 1);

	 if (chelp){
	   g_free(chelp);
	   chelp = NULL;
	 }
	 return 1;
}









int iTATA=0;
void getNextSongInXmmsShuffleList(){

  int playing = 0;
  gchar *gcHelp;

  if (!xmms_remote_is_shuffle(rateplug.xmms_session)) {
    if (xmms_remote_is_repeat(rateplug.xmms_session)){
        strNextSongGetNextSongInXmmsShuffleList = (gcHelp = xmms_remote_get_playlist_file(rateplug.xmms_session, 0));
	if (gcHelp) {
	  g_free(gcHelp);
	  gcHelp = NULL;
	}
    }
	else {
	  strNextSongGetNextSongInXmmsShuffleList="";
	}
  return;
  }

  reinitXmmsShuffle();

  if (xmms_remote_is_playing(rateplug.xmms_session)) {
    playing = 1;
    xmms_remote_stop(rateplug.xmms_session);
  }  
  
  iTATA = xmms_remote_get_playlist_pos(rateplug.xmms_session);

  xmms_remote_playlist_next(rateplug.xmms_session);

  if (!iTimeoutGetNextSongInXmmsShuffleList){
      iTimeoutGetNextSongInXmmsShuffleList = gtk_timeout_add(config->iTimeout/2, timeoutGetNextSongInXmmsShuffleList, (void *)playing);
  }

   
   return;

} /*end getNextSongInXmmsShuffleList()*/


gint timeoutGetNextSongInXmmsShuffleList(gpointer gP){
  
  gchar *gcHelp;
  
  gtk_timeout_remove(iTimeoutGetNextSongInXmmsShuffleList);
  iTimeoutGetNextSongInXmmsShuffleList=0;
  strNextSongGetNextSongInXmmsShuffleList = (gcHelp = xmms_remote_get_playlist_file(rateplug.xmms_session, xmms_remote_get_playlist_pos(rateplug.xmms_session)));
  if (gcHelp){
    g_free(gcHelp);
    gcHelp=NULL;
  }

  xmms_remote_set_playlist_pos(rateplug.xmms_session, iTATA);
  //  xmms_remote_playlist_prev(rateplug.xmms_session);
  if ((int)gP) {
    xmms_remote_play(rateplug.xmms_session);
  }

    iSongChangedInLastTimeout = 0;

  return 1;
}/*end timeoutGetNextSongInXmmsShuffleList()*/





